#include<iostream>
#include<fstream>
#include<time.h>
#include<vector>
#include<algorithm>
#include<iterator>
#include <cmath>

void createDataWithStream() 
{
	std::ofstream file("File.txt");
	srand(time(nullptr));
	if (!file.is_open()) 
	{
		std::cerr << "ERROR, file cant be opened";
		exit(EXIT_FAILURE);
	}

	for (int i = 0; i < 100; i++) 
	{
		file << rand() % 101 - 50 << " ";
	}

	file.close();
}

void createDataWithGenerate() 
{
	std::vector<int> vector1(100);
	std::ofstream file("File.txt");
	srand(time(nullptr));
	if (!file.is_open()) 
	{
		std::cerr << "ERROR, file cant be opened";
		exit(EXIT_FAILURE);
	}

	std::generate(vector1.begin(), vector1.end(), 
		[]() {return rand() % 101 - 50; });
	std::copy(vector1.begin(), vector1.end(), std::ostream_iterator<int>(file, " "));
	
	file.close();
}

template <typename T>
void loadDataWithStream(T& container) 
{
	std::ifstream file("File.txt");
	if (!file.is_open()) 
	{
		std::cerr << "ERROR, file cant be opened";
		exit(EXIT_FAILURE);
	}
	typename T::value_type element;
	while (!file.eof())
	{
		file >> element;
		container.push_back(element);
	}

	file.close();
}

template <typename T>
void loadDataWithCopy(T& container) 
{
	std::ifstream file("File.txt");
	if (!file.is_open()) 
	{
		std::cerr << "ERROR, file cant be opened";
		exit(EXIT_FAILURE);
	}
	std::copy(std::istream_iterator<typename T::value_type>(file), std::istream_iterator<typename T::value_type>(), back_inserter(container));
	file.close();
}

template <typename T>
void modify1(T& container) 
{
	double sum = 0;
	for (const auto& element : container)
		sum += element;
	if (container.empty())
	{
		std::cerr << "Error, you have not yet loaded the data";
		exit(EXIT_FAILURE);
	}
	auto iter = container.end()-1;
	double multiplication = *(std::max_element(container.begin(),container.end()))*(*iter);
	std::cout << "maximum element in the container: " << *(std::max_element(container.begin(), container.end())) << std::endl
		<< "the last element in the container: " << *iter << std::endl
		<< "the square root of absolute multiplication: " << std::sqrt(abs(multiplication)) << std::endl
		<< "absolute sum of all elements: " << abs(sum) << std::endl
		<< "absolute arithmetic mean (sum/100): " << abs(sum / 100) << std::endl;
	for (auto& element : container)
	{
		element += std::sqrt(abs(multiplication));
	}
	container.push_back(abs(sum));
	container.push_back(abs(sum / 100));
}


template <typename T>
void modify2(const T& iter_begin, const T& iter_end) 
{
	if (iter_begin==iter_end)
	{
		std::cerr << "Error, you have not yet loaded the data";
		exit(EXIT_FAILURE);
	}
	auto iter = iter_end - 1;
	double multiplication = *(std::max_element(iter_begin, iter_end)) * (*iter);
	std::cout << "maximum element in the container: " << *(std::max_element(iter_begin, iter_end)) << std::endl
		<< "the last element in the container: " << *iter << std::endl
		<< "the square root of absolute multiplication: " << std::sqrt(abs(multiplication)) << std::endl;
	for (auto it = iter_begin; it != iter_end; ++it)
	{
		*(it) += std::sqrt(abs(multiplication));
	}
}

template <typename T>
void modify3(T& container) 
{
	if (container.empty())
	{
		std::cerr << "Error, you have not yet loaded the data";
		exit(EXIT_FAILURE);
	}

	auto iter = container.end() - 1;
	double multiplication = *(std::max_element(container.begin(), container.end())) * (*iter);
	std::cout << "maximum element in the container: " << *(std::max_element(container.begin(), container.end())) << std::endl
		<< "the last element in the container: " << *iter << std::endl
		<< "the square root of absolute multiplication: " << std::sqrt(abs(multiplication)) << std::endl;
	auto change = [&multiplication](auto& element) // -
	{
		element += std::sqrt(abs(multiplication));
	};
	std::for_each(container.begin(), container.end(), change);

}

template <typename T>
void modify4(T& container) 
{
	std::ifstream file("File.txt");
	std::ofstream file_out("File2.txt");
	if (!file.is_open()) 
	{
		std::cerr << "ERROR, file cant be opened";
		exit(EXIT_FAILURE);
	}
	auto iter = container.end() - 1;
	double multiplication = *(std::max_element(container.begin(), container.end())) * (*iter);
	std::cout << "maximum element in the container: " << *(std::max_element(container.begin(), container.end())) << std::endl
		<< "the last element in the container: " << *iter << std::endl
		<< "the square root of absolute multiplication: " << std::sqrt(abs(multiplication)) << std::endl;

	auto change = [&multiplication](auto& element) // -
	{
		return (element + std::sqrt(abs(multiplication)));
	};
	
	std::transform(
		std::istream_iterator<typename T::value_type>(file), 
		std::istream_iterator<typename T::value_type>(),
		std::ostream_iterator<typename T::value_type>(file_out, " "), change);

	file.close();
	file_out.close();
	
	file_out.open("File2.txt", std::ios::in);
	std::cout << file_out.rdbuf();
	std::cout << std::endl;
	file_out.close();
}


template<typename T>
void outputResultStream(T& container) 
{
	if (container.empty())
	{
		std::cerr << "Error, you have not yet loaded the data";
		exit(EXIT_FAILURE);
	}
	std::ofstream file_out("File_result.txt");

	for (const auto& element : container) 
	{
		file_out << element << " ";
	}

	file_out.close();

	std::cout << " Result: " << std::endl;
	file_out.open("File_result.txt", std::ios::in);
	std::cout << file_out.rdbuf();
	std::cout << std::endl;
	file_out.close();
}

template<typename T>
void outputResultCopy(T& container) 
{
	if (container.empty())
	{
		std::cerr << "Error, you have not yet loaded the data";
		exit(EXIT_FAILURE);
	}
	std::ofstream file_out("File_result.txt");
	std::copy(container.begin(), container.end(), std::ostream_iterator<typename T::value_type>(file_out, " "));

	file_out.close();

	std::cout << " Result: " << std::endl;
	std::ostream_iterator <typename T::value_type> input(std::cout, " ");
	std::copy(container.begin(), container.end(), input);
	std::cout << std::endl;
}

