#include "bank.h"

Bank::Bank(const char* surname, const char* date1, int acc_num, int acc_id, int sum1, double percent):
	account_number(acc_num),
	account_id(acc_id),
	sum(sum1),
	annual_percent(percent)
{
	strcpy_s(clients_surname, surname);
	strcpy_s(date, date);
}

Bank::Bank(const Bank& new_bank):
	account_number(new_bank.account_number),
	account_id(new_bank.account_id),
	sum(new_bank.sum),
	annual_percent(new_bank.annual_percent)
{
	strcpy_s(clients_surname, new_bank.clients_surname);
	strcpy_s(date, new_bank.date);
}
Bank& Bank::operator=(const Bank& new_bank)
{
	if (this != &new_bank)
	{
		strcpy_s(clients_surname, new_bank.clients_surname);
		strcpy_s(date, new_bank.date);
		account_number = new_bank.account_number;
		account_id = new_bank.account_id;
		sum = new_bank.sum;
		annual_percent = new_bank.annual_percent;
	}
	return *this;
}

std::istream& operator >> (std::istream& ptr_in, Bank& new_bank)
{
	ptr_in >> new_bank.clients_surname
		>> new_bank.date
		>> new_bank.account_number
		>> new_bank.account_id
		>> new_bank.sum
		>> new_bank.annual_percent;
	return ptr_in;
}

std::ostream& operator << (std::ostream& ptr_out, const Bank& new_bank)
{
	ptr_out << new_bank.clients_surname << std::endl
		<< new_bank.date << std::endl
		<< new_bank.account_number << std::endl
		<< new_bank.account_id << std::endl
		<< new_bank.sum << std::endl
		<< new_bank.annual_percent << std::endl;
	return ptr_out;
}
